/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package JSTL_WS_package;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;

/**
 *
 * @author damienl
 * 
 * Méthodes utilisables
 */
public class Methods {
    
    public static final Logger log = Logger.getLogger(WebService_JSTL.class.getName());
    
    // generation d'un vecteur de bierwirth canonique
     public void generer_can_bierwirth (Solution une_solution, Probleme un_probleme, Random r) {
        // Job : tableau des jobs restant à ajouter au vecteur de Bierwirth
        // timeSeeingPiece : nombre de traitements restants sur le job i 
	int i, nbmac = un_probleme.nbmac, nbjob = un_probleme.nbjob, indiceBierwirth=0;
        int ordoJobs[] = new int [nbjob];
        int jobs[] = new int [nbjob];
        int randomJob, ordoJob=0;
        int ordoNbJob=nbjob-1;
	
        // initialisation des tableaux 
	for (i=0; i<nbjob; ++i) {
            jobs[i]=i; // changer parce que mac = 0 existe dans les laXX
	}
        
        // init ordre des jobs
        while(ordoNbJob>=0) {
            if (ordoNbJob > 0) {
                randomJob = r.nextInt(ordoNbJob);
            } else {
                randomJob = 0;
            }
            ordoJobs[ordoJob++]=jobs[randomJob];
            jobs[randomJob]=jobs[ordoNbJob--];
        }
        
        indiceBierwirth=0;
        for (i = 0; i < nbjob; ++i) {
            for (int j=0; j< nbmac; ++j) {
                une_solution.vecteur[indiceBierwirth++] = ordoJobs[i];
            }
        }
        indiceBierwirth=0;
    }
         
    // génération d'un vecteur de Bierwirth aléatoire
    public static void generer_rand_bierwirth (Solution une_solution, Probleme un_probleme, Random r) {
        // Job : tableau des jobs restant à ajouter au vecteur de Bierwirth
        // timeSeeingPiece : nombre de traitements restants sur le job i 
	int i, j, nbmac = un_probleme.nbmac, nbjob = un_probleme.nbjob, n;
	int timeSeeingPiece[] = new int [un_probleme.nbjob];
        int Job[] = new int [un_probleme.nbjob];

	n = nbmac * nbjob;

	// initialisation des tableaux 
	for (i=0; i<nbjob; ++i) {
            timeSeeingPiece[i] = nbmac;
            Job[i]=i;
	}

	for (i=0; i<n; ++i) {
            j = r.nextInt(nbjob);		// generation d'un entier aléatoire
            une_solution.vecteur[i] = Job[j];	// stockage du job correspondant
            timeSeeingPiece[j]--;                           // on decremente le nombre de machines pour le job j
            if (timeSeeingPiece[j] == 0) {
                timeSeeingPiece[j] = timeSeeingPiece[nbjob-1];          // on recupere le nombre de machines d'un job non terminé	
                Job[j] = Job[--nbjob];              // N[j] reçoit un job non totalement traité et on décremente le nombre de jobs restant à traiter
            }	
	}
    }
         
    //méthode retournant le premier sommet dont le TL max est violé
    public  int returnFirstBrokenVertex(Solution une_sol, Probleme un_prob) {
        int nbjob = un_prob.nbjob, nbmac = un_prob.nbmac;
        int index =nbjob*nbmac;
        int job=0, mac, brokenVertex=-1;
        boolean exit = false;
        int k = 0;
        int[] timeSeeingPiece = new int[nbjob];
        // initialisation des tableaux 
	for (int i=0; i<nbjob; ++i) {
            timeSeeingPiece[i] = 0;
	}
        
        while (!exit &&  k < index) {
            job = une_sol.vecteur[k++];
            if (timeSeeingPiece[job]>0) {
                mac = timeSeeingPiece[job];
                timeSeeingPiece[job]++;
                if (une_sol.date[job*nbmac+mac] + un_prob.liste_operation[job][mac-1].arcRetour > une_sol.date[job*nbmac+mac-1]) {
                    exit = true;
                    brokenVertex=job*nbmac+mac;
                }
            } else {
                timeSeeingPiece[job]++;
            }
        }
        return brokenVertex;
    }
    
    // méthode de recherche de l'indice dans bierwirth de l'étape d'un job
    public  int searchBierwirth(Solution une_solution, int job, int mac) {
        int i = 0, countMac = 0;
        while (countMac < mac) {
            if (une_solution.vecteur[i] == job) {
                countMac++;
            }
            ++i;
        }
        // i-1 car on est sur l'indice suivant 
        return i-1;
    }
    
    //méthode de recherche de l'étape d'une machine en fonction de l'indice
    public  int searchMacBierwirth(Solution une_solution, int indice) {
        int mac = 1, count = 0;
        while (count < indice) {
            if (une_solution.vecteur[count++] == une_solution.vecteur[indice]) {
                mac++;
            }
        }
        // i-1 car on est sur l'indice suivant 
        return mac;
    }
      
    // méthode permettant de savoir si deux sommets du graphe appartienent au même Job
    public  boolean meme_job (Probleme un_probleme, int sommet1, int sommet2) {
        // variable locale contenant le nombre de machines du probleme
        int nbmac = un_probleme.nbmac;
        return ((sommet1 / nbmac) == (sommet2 / nbmac));
    }
      
    // permutation dans Bierwirth
    public  void echanger (Solution une_solution, int sommet1, int sommet2) {
        int tmp = une_solution.vecteur[sommet1];
        une_solution.vecteur[sommet1] = une_solution.vecteur[sommet2];
        une_solution.vecteur[sommet2] = tmp;
    }
    
    
    // méthode retournant le nombre de TL max violés
    public int countBrokenTL(Solution une_sol, Probleme un_prob) {
        int nbjob = un_prob.nbjob, nbmac = un_prob.nbmac;
        int job=0, mac, nbBrokenTL=0;
        
        while ( job < nbjob) {
            mac = 1;
            while ( mac < nbmac) {
                if (une_sol.date[job*nbmac+mac] + un_prob.liste_operation[job][mac-1].arcRetour > une_sol.date[job*nbmac+mac-1]) {
                    ++nbBrokenTL;
                }
                mac++;
            }
            job++;
        }
        return nbBrokenTL;
    }  
    
    // méthode de recherche locale
    public void recherche_locale (Solution une_solution, Probleme un_probleme) {
	// variables locales
	int i, j, nbmac = un_probleme.nbmac, nbjob = un_probleme.nbjob, n, iter;
	int cour, pere, N1, N2, adN1, adN2, ocN1, ocN2, job1, job2, minAdN;
	Solution solution_locale = new Solution (un_probleme);

	n = nbjob * nbmac;
        
        //Initialisation sinon le compil gueule
        adN1 = -1;
        adN2 = -1;
	
	// initialisation des deux premieres valeurs à la fin du chemin critique
	cour = une_solution.critique[n];
	pere = une_solution.critique[cour];
	
	//tant qu'on n'a pas tout parcouru
        iter = 0;
	while (pere != -1 & iter < un_probleme.itermax)
	{
            ++iter;
            // si cour et pere appartiennent a des jobs differents
            if (! meme_job(un_probleme, cour, pere)) {
                solution_locale.Copie (une_solution, un_probleme);		// on sauvegarde la solution connue
                job1 = cour / nbmac;					// on recupere le numero des jobs coorespondant a cour et pere
                job2 = pere / nbmac;
                N1 = cour % nbmac + 1;				// on recupere la position de cour et de pere dans les deux gammes
                N2 = pere % nbmac + 1;
                //initialisations
                ocN1 = 0;
                ocN2 = 0;
                i = 0;

                // recherche des sommets à intervertir
                while (ocN1 < N1 || ocN2 < N2)
                {
                    if (solution_locale.vecteur[i] == job1) {
                        ocN1++;
                        if (ocN1 == N1)
                            adN1 = i;
                    }
                    if (solution_locale.vecteur[i] == job2) {
                        ocN2++;
                        if (ocN2 == N2)
                            adN2 = i;
                    }
                    ++i;
                }

                // on inverse les données dans la solution locale
                echanger (solution_locale, adN1, adN2);
                minAdN = adN1;
                if (adN2 < minAdN)
                    minAdN = adN2;

                evaluate(solution_locale, un_probleme, minAdN, false);
                
                // si le cout de la solution locale est meilleur que celui de la solution connue
                if (solution_locale.cout < une_solution.cout) {
                    // on modifie la solution
                    une_solution.Copie(solution_locale, un_probleme);
                    // on reaffecte cour et pere
                    iter=0;
                    cour = une_solution.critique[n];
                    pere = une_solution.critique[cour];
                } else {  // sinon on continue d'avancer le long du chemin critique connu
                    cour = pere;
                    pere = une_solution.critique[cour];
                }	
            } else {  // sinon on avance
                cour = pere;
                pere = une_solution.critique[cour];
            }
	}
    }
    
    // méthode de calcul du chemin critique du graphe
    public static void chemin_critique (Solution une_solution, Probleme un_probleme) {
	int cour, pere, i;
	int nbmac = un_probleme.nbmac, nbjob = un_probleme.nbjob, n = nbjob * nbmac;

	cour = n;
	pere = une_solution.pere[n];

	for (i=0; i<=n; ++i)
            une_solution.critique[i] = -1;
        
	while (cour != -1) {
            une_solution.critique[cour] = pere;
            cour = pere;
            if (pere != -1)
                pere = une_solution.pere[cour];
	}
    }

    
    //fonction de décalage d'un job dans le vecteur de Bierwirth
    public int decalageBierwirth(Probleme un_prob, Solution une_solution, int indiceJob) {
        // recherche de l'etape dans le job en cours
        int etape = searchMacBierwirth(une_solution, indiceJob);
        int job = une_solution.vecteur[indiceJob];
        int nbmac = un_prob.nbmac;
        int pere=une_solution.pere[job*nbmac+etape-1]/nbmac;
        int macJob = un_prob.liste_operation[job][etape-1].numero;
        
        // recherche de l'indice du numero de cette machine pour le job pere
        int j = 0;
        while (un_prob.liste_operation[pere][j].numero != macJob) ++j;
        
        int indicePere = searchBierwirth(une_solution, pere, j+1);
        
        // permut dans Bierwirth
        une_solution.vecteur[indicePere] = job;
        une_solution.vecteur[indiceJob] = pere;
        
        return indicePere;
    }
    
    // méthode de réparation d'une solution
    public void repairSolution(Probleme un_probleme, Solution une_sol, int nbMax) {
        int nbmac = un_probleme.nbmac, cpt = 0;
        int indexBrokenVertex = 0, indexVertexModified = 0, lastVertexModified=0;
        boolean exit = false;
        // recherche du premier sommet posant probleme
        int brokenVertex = returnFirstBrokenVertex(une_sol, un_probleme);
        while (++cpt<nbMax && brokenVertex != -1 && !exit) {
            // si le sommet est sur un cycle positif
            if (isPosCyc(un_probleme, une_sol, brokenVertex)) { // on essaye de réparer le cycle
                // on cherche à quel indice de bierwirth correspond le sommet à traiter
                indexBrokenVertex = searchBierwirth(une_sol, brokenVertex/nbmac, brokenVertex%nbmac+1);
                // on place le sommet avant son prédécesseur pour casser le problème
                indexVertexModified=decalageBierwirth(un_probleme, une_sol, indexBrokenVertex);
                // on réévalue la boucle en prenant en compte les slides
                evaluate(une_sol, un_probleme, indexVertexModified, false);
            } else {
                // sinon on effectue des glissements en amont
                lastVertexModified = sliding(une_sol, un_probleme, brokenVertex, exit);
                indexVertexModified = searchBierwirth(une_sol, lastVertexModified/nbmac, lastVertexModified%nbmac+1);
                // on évalue la solution dont les dates ont bougé à cause du glissement 
                evaluate(une_sol, un_probleme, indexVertexModified+1, false);
            }
            // on cherche le nouveau sommet posant probleme
            brokenVertex = returnFirstBrokenVertex(une_sol, un_probleme);
        }
    }
    
    // méthode de modification des dates de début des sommets du graphe sur une gamme horizontale
    public int sliding (Solution une_solution, Probleme un_probleme, int sommet, boolean posCyc) {
        // sommet >= 1
        int nbmac = un_probleme.nbmac;
        int jobSommet = sommet/nbmac,macSommet = sommet%nbmac;
        // on décale les dates sur le chemin horizontal tant qu'il faut
        
        while (macSommet >= 1 && (!isPosCyc(un_probleme, une_solution, jobSommet*nbmac+macSommet))  && (une_solution.date[jobSommet*nbmac+macSommet] + (un_probleme.liste_operation[jobSommet][macSommet-1].arcRetour) > une_solution.date[jobSommet*nbmac+macSommet-1] )) {
            // on modifie la date du sommet précédent  
            une_solution.date[jobSommet*nbmac+macSommet-1]=une_solution.date[jobSommet*nbmac+macSommet]+un_probleme.liste_operation[jobSommet][macSommet-1].arcRetour;
            macSommet--;
        }  
        // on retourne le dernier sommet modifié
        return jobSommet*nbmac+macSommet;
    }
    
    // fonction d'évaluation 
    public void evaluate(Solution une_solution, Probleme un_probleme, int start, boolean repair) {
	// variables locales
        //	lastPieceOnMac[i] : numero de la derniere piece passée sur la machine i 
        //	timeSeeingPiece[i] : nombre de fois où on a trouvé la piece i
        //	i,j : variables de boucle
        //	nbmac, nbjob, n : nombre de machines, de jobs, et de sommets
        // 	piece, machine : numero de la piece et de la machine en cours
        //	pos_piece : position de la piece
        //	piece_prec : position de la piece precedente
        //	pos_prec_hor, pos_prec_disj : position horizontal ou disjonctive
        //	prec_disj:
        //	datePH : date de passage horizontal
        //	datePD : date de passage disjonctif
        //	d1, d2 : dates de passage à comparer
        //	d : date de passage retenue
        //	pere : 	 pere du sommet en cours
        //	temps :  durée finale
	int nbmac = un_probleme.nbmac, nbjob = un_probleme.nbjob;
        int n = nbmac*nbjob, sommet = 0;
        int lastPieceOnMac[] = new int [nbmac];
        int timeSeeingPiece[] = new int [nbjob];
	int piece =0, piece_prec=0, machine=0;
        int pos_piece=0,  pos_prec_hor=0, pos_prec_disj=0, prec_disj=-1;
        int datePrecHoriz=0, datePrecDisj=0, dateHoriz = 0, dateDisj = 0, date =0, pere=0, temps = 0;
        int job, indiceJob, mac, indiceMac;
        
	// initialisation des tableaux necessaires
	for (indiceMac=0; indiceMac<nbmac; ++indiceMac) {
            lastPieceOnMac[indiceMac] = -1;
        }

	for (job=0; job<nbjob; ++job) {
            timeSeeingPiece[job] = 0;
        }
        
        for (indiceJob=0; indiceJob< start; ++indiceJob) {
            job = une_solution.vecteur[indiceJob];
            timeSeeingPiece[job] += 1;
            lastPieceOnMac[un_probleme.liste_operation[job][timeSeeingPiece[job]-1].numero] = job;
        }
        
        // reinitialisation tableau des successeurs
        if (repair) {
            for (job=0;job<nbjob;++job) {
                for (mac = timeSeeingPiece[job]; mac < nbmac; ++mac) {
                    une_solution.succDisj[job*nbmac+mac]=-1;
                }
            }
        }
        
	for (indiceJob=start; indiceJob<n; ++indiceJob) {
            // initialisations des durées
            dateHoriz = 0;
            dateDisj = 0;
            prec_disj = -1;
            datePrecDisj = 0;
            datePrecHoriz = 0;
            piece = une_solution.vecteur[indiceJob];                                        // numero de la piece dans bierwirth
            if (timeSeeingPiece[piece] < nbmac) {
                machine = un_probleme.liste_operation[piece][timeSeeingPiece[piece]].numero;          // numero de machine ou se trouve la piece
                timeSeeingPiece[piece]+=1;                                                            // on incremente le nombre d'operation sur la piece
                pos_piece = un_probleme.machine[machine][piece];                        // position de la piece dans la gamme

                if (pos_piece != 0) {	// si la piece n'est pas en debut de gamme
                    pos_prec_hor = pos_piece - 1; 								// on recupere la piece precedente dans la gamme
                    datePrecHoriz = une_solution.date[un_probleme.liste_operation[piece][pos_prec_hor].sommet];       // on recupere la date de fin au plus tot de la piece precedente dans la meme gamme
                    dateHoriz = datePrecHoriz + un_probleme.liste_operation[piece][pos_prec_hor].dureeHoriz;                   // on calcule la date de fin au plus tot horizontalement	
                }

                if (lastPieceOnMac[machine] != -1) {     // si une autre piece est passe avant sur la meme machine
                    piece_prec = lastPieceOnMac[machine]; 															// on recupere le numero de la piece passe avant sur la machine
                    pos_prec_disj = un_probleme.machine[machine][piece_prec];                       // on recupere la position de la piece passe avant dans sa gamme
                    prec_disj = un_probleme.liste_operation[piece_prec][pos_prec_disj].sommet;
                    datePrecDisj = une_solution.date[prec_disj];						//on recupere la date de fin au plus tot de la piece precedente sur la meme machine
                    dateDisj = datePrecDisj + un_probleme.liste_operation[piece_prec][pos_prec_disj].dureeDisj;
                }

                date = dateDisj;             // on retient d2
                pere = prec_disj;           // on retient le pere
                if (dateHoriz > date) {     // si d1 est alors superieure à d
                    date = dateHoriz;             // on retient d1
                    pere = un_probleme.liste_operation[piece][pos_piece - 1].sommet;	// on retient le pere
                }

                
                // on sauvegarde les données dans la solution
                une_solution.date[un_probleme.liste_operation[piece][pos_piece].sommet] = date;			
                une_solution.pere[un_probleme.liste_operation[piece][pos_piece].sommet] = pere;
                lastPieceOnMac[machine] = piece;	// la piece en cours est la derniere à etre passée sur la machine 

                if (repair) {
                    sommet = piece*nbmac+pos_piece;
                    if (prec_disj != -1) { // dateHoriz <= donc il y a un predecesseur disj
                        une_solution.succDisj[prec_disj]=sommet; // on sauvegarde le successeur du pere
                    }
                    if (pos_piece>0 ) {
                        smallRepair(un_probleme, une_solution, sommet);
                    }
                }
            }
	}

	// phase de calcul du COUT selon la durée des arcs terminaux
	temps = 0;
	for (job=0; job<nbjob; ++job) {
            date = une_solution.date[un_probleme.liste_operation[job][nbmac-1].sommet] + un_probleme.liste_operation[job][nbmac-1].dureeHoriz;
            if (date > temps) {			
                temps = date;
                pos_piece = un_probleme.liste_operation[job][nbmac-1].sommet;
            }
	}

        une_solution.cout = countBrokenTL(une_solution, un_probleme)*un_probleme.biCriteria+temps;
        
        une_solution.pere[n] = pos_piece;
	chemin_critique (une_solution, un_probleme);        // on recherche le chemin critique

    }

    
    //fonction de calcul de la valeur de hachage sur tous les sommets
    public static int hash_Sommets (Solution une_solution, Probleme un_probleme, int sizeTabHash) {
        int nbmac = un_probleme.nbmac, nbjob = un_probleme.nbjob, n = nbjob * nbmac;
        int i,  j =n;
        long hach = 0, hach1 =0;
        for (i=0; i < nbjob; ++i) {
            for (j=0; j<nbmac; ++j) {
                hach1 = une_solution.date[i*nbmac+j];
                hach += (hach1*hach1);
            }
        }
        return (int) (hach%sizeTabHash);
    }
    
    
    // méthode pour savoir si le sommet est sur un chemin de longueur positive
    public  boolean isPosCyc(Probleme un_prob, Solution une_sol, int sommet) {
        int nbmac = un_prob.nbmac;
        int job = sommet/nbmac;
        int pere = une_sol.pere[sommet];
        int cost = 0;
        boolean isPositiveCycle = false;

        int succ = job; // successeur pour savoir si on prend une date Disj ou horiz
        while ((pere != -1) && (pere/nbmac != job)) {
            
            if (pere/nbmac == succ) { // duree horiz
                cost += un_prob.liste_operation[succ][pere%nbmac].dureeHoriz;
            } else { // durée disj
                cost += un_prob.liste_operation[pere/nbmac][pere%nbmac].dureeDisj;
            }
            succ = pere/nbmac; // on garde le job en cours
            pere=une_sol.pere[pere];
        }

        if ((pere != -1) && (pere/nbmac == job)) {
            cost += un_prob.liste_operation[pere/nbmac][pere%nbmac].dureeDisj;
            int etape1 = sommet%nbmac;
            int etape2 = pere%nbmac;
            int i = etape1;
            while( i >= etape2+1) {
                cost+=un_prob.liste_operation[job][--i].arcRetour;
            }
        }

        if (pere != -1 && cost > 0) {
            isPositiveCycle = true;
        }


        return isPositiveCycle;
    }
    
    
    // génération d'un voisin
    public Solution generer_voisin (Solution une_solution, Probleme un_probleme, Random r) {
	int nbmac = un_probleme.nbmac, nbjob = un_probleme.nbjob, n = nbjob * nbmac;
	// on genere deux entiers aleatoires 
        int a = r.nextInt(n), b=r.nextInt(n);
	Solution voisin = new Solution (une_solution, un_probleme);

	// tant qu'on n'a pas deux jobs differents
	while (voisin.vecteur[a] == voisin.vecteur[b]) {
            b = r.nextInt(n);		// on regenere un entier
        }

	//on echange les deux valeures
	echanger (voisin, a, b);
        if (a < b) {
            evaluate(voisin, un_probleme, a, false);
        } else {
            evaluate(voisin, un_probleme, b, false);
        }
        return voisin;
    }
    
    // réparation des dates n'impactant aucun sommet disjonctif
    // réparation des dates n'impactant aucun sommet disjonctif
    public static void smallRepair(Probleme un_probleme, Solution une_solution, int sommet) {
       // on ne répare les TL cassés que si aucun sommets dont on modifie la date de début n'a de successeurs
        int  nbmac = un_probleme.nbmac, dateDeb=0;
        int jobSommet = sommet/nbmac,macSommet = sommet%nbmac, succDisj=0;
        boolean exit = false;
        // on a un problème sur une date
        while (macSommet>=1 && !exit && une_solution.date[jobSommet*nbmac+macSommet] + (un_probleme.liste_operation[jobSommet][macSommet-1].arcRetour) > une_solution.date[jobSommet*nbmac+macSommet-1] ) {
            // date à laquelle l'operation devrait commencer
            dateDeb=une_solution.date[jobSommet*nbmac+macSommet]+un_probleme.liste_operation[jobSommet][macSommet-1].arcRetour;
            succDisj=une_solution.succDisj[jobSommet*nbmac+macSommet-1];
            if((succDisj < 0) || (succDisj>=0 && (dateDeb+un_probleme.liste_operation[jobSommet][macSommet-1].dureeDisj)<une_solution.date[succDisj])) {
                une_solution.date[jobSommet*nbmac+macSommet-1]=dateDeb;
                macSommet--;
            } else {
                exit = true;
            }
        }  
    }
    
    
    
    //generation d'un diagramme de gantt exportable en byte[]
    public byte[] createGantt(Probleme un_probleme, Solution best_solution, String titleExt) {
       
        int i, job, mac, pos;
        int nbmac = un_probleme.nbmac, nbjob=un_probleme.nbjob;
        int margin = 40;
        int marginBetweenRect = 5;
        int fleche = 20;
        int rectWidth = 50;
        Random rand = new Random();
        Color col = null;
        int xStart=0,xLength=0,yStart=0,yLength=0, stringLen=0;
        String str = null;
        
        
        // retrouver cout reel de la solution
        int bestSolCost = (int)(best_solution.cout-(countBrokenTL(best_solution, un_probleme)*un_probleme.biCriteria));
        
        
        /*----------------------------------------------------------------------
            Ratio pour taille des rectangles du diagramme
        ----------------------------------------------------------------------*/
        int ratio =1;
        if (bestSolCost <500) {
            if (bestSolCost<=30) {
                ratio = 20;
            } else if (bestSolCost < 100) {
                ratio = 10;
            } else if (bestSolCost < 250) {
                ratio = 5;
            } else if (bestSolCost < 500) {
                ratio = 2;
            } 
        }

        int maxDiagLength = ratio*bestSolCost+2*margin+fleche+un_probleme.nbmac;
        int maxDiagHeight = (rectWidth+marginBetweenRect)*un_probleme.nbmac+margin+fleche+10;
        
        byte[] imageInByte = null;
        float[] hsbcol = new float[3];
        
        /*----------------------------------------------------------------------
            Création de la palette de couleurs
        ----------------------------------------------------------------------*/
        Color[] colors = new Color[nbjob];
        
        for (i=0; i < nbjob; ++i) {
            Color.RGBtoHSB(rand.nextInt(255), rand.nextInt(255), rand.nextInt(255), hsbcol);
            colors[i]=Color.getHSBColor(hsbcol[0], hsbcol[1], hsbcol[2]);
        }
        
        BufferedImage image = new BufferedImage( maxDiagLength , maxDiagHeight , BufferedImage.TYPE_INT_RGB);
        Graphics2D buffer = (Graphics2D) image.createGraphics();
         
        buffer.setColor( Color.white );
        buffer.fillRect( 0, 0, maxDiagLength , maxDiagHeight );

        buffer.setStroke(new BasicStroke(2.0f));

        Font font = new Font("Times New Roman", Font.BOLD, 9);
        buffer.setFont(font);
        
        int[] macused = new int[nbmac];
        for (i=0; i < nbmac; ++i) {
            macused[i] = 0;
        }
        
        for (i=0; i < nbmac*nbjob; i++) {
            job = i/nbmac;
            pos = i%nbmac;
            mac = un_probleme.liste_operation[job][pos].numero;
            col = colors[job];
            
            xStart = margin + ratio*best_solution.date[i]+marginBetweenRect;
            xLength = ratio*un_probleme.liste_operation[job][pos].dureeDisj-marginBetweenRect;
            yStart = margin + mac*rectWidth+marginBetweenRect;
            yLength = rectWidth-marginBetweenRect;

            buffer.setColor(col);
            buffer.fillRect(xStart, yStart, xLength , yLength);
            
            buffer.setColor(col.darker());
            buffer.drawRect(xStart, yStart, xLength , yLength);
        }
        
        for (i=0; i < nbmac*nbjob; i++) {
            buffer.setColor(Color.BLACK);
            job = i/nbmac;
            pos = i%nbmac;
            mac = un_probleme.liste_operation[job][pos].numero;
            xStart = margin + ratio*best_solution.date[i]+marginBetweenRect;
            xLength = ratio*un_probleme.liste_operation[job][pos].dureeDisj-marginBetweenRect;
            yStart = margin + mac*rectWidth+marginBetweenRect;
            yLength = rectWidth-marginBetweenRect;

            str = "J " + job;
            stringLen = (int) buffer.getFontMetrics().getStringBounds(str, buffer).getWidth();
            buffer.drawString(str,  (xLength+2*xStart)/2 -stringLen/2 , yStart+15);

            str = Integer.toString(best_solution.date[i]);
            stringLen = (int) buffer.getFontMetrics().getStringBounds(str, buffer).getWidth();
            buffer.drawString(str,  (xLength+2*xStart)/2 -stringLen/2 , yStart+25);

            str = Integer.toString(best_solution.date[i]+un_probleme.liste_operation[job][pos].dureeDisj);
            stringLen = (int) buffer.getFontMetrics().getStringBounds(str, buffer).getWidth();
            buffer.drawString(str,  (xLength+2*xStart)/2 -stringLen/2 , yStart+35);

            
        }
        
        buffer.setColor(Color.DARK_GRAY);
        // vertical
        buffer.drawLine(margin, margin-fleche , margin, margin + nbmac*rectWidth+marginBetweenRect);
        buffer.drawLine(margin, margin-fleche , margin+10, margin-fleche+10);

        for (i = 1; i <= nbmac; ++i){
            buffer.drawString("M."+i,  margin-25, margin-fleche+i*rectWidth);
        }
       
        //horizontal
        buffer.drawLine(margin, margin + nbmac*rectWidth+marginBetweenRect , margin + ratio*bestSolCost+fleche, margin + nbmac*rectWidth+marginBetweenRect);
        buffer.drawLine(margin + ratio*bestSolCost+fleche-10, margin + nbmac*rectWidth+marginBetweenRect-10, margin + ratio*bestSolCost+fleche, margin + nbmac*rectWidth+marginBetweenRect);

        buffer.drawString("Stages", margin+10, margin-fleche+5);
        buffer.drawString("Time", margin + ratio*bestSolCost+fleche, margin + nbmac*rectWidth+marginBetweenRect-5);
        
        buffer.setColor(Color.RED);
        Font newFont = new Font("Verdana", Font.BOLD, 10);
        buffer.setFont(newFont);
        buffer.drawString(Integer.toString(bestSolCost), margin + ratio*bestSolCost+2, margin + nbmac*rectWidth+marginBetweenRect+12);
        buffer.drawLine(margin + ratio*bestSolCost, margin + nbmac*rectWidth+marginBetweenRect +2, margin+ratio*bestSolCost, margin + nbmac*rectWidth+marginBetweenRect+10);     
        
        String title = "Diagramme de Gantt du problème " + titleExt;

        stringLen = (int) buffer.getFontMetrics().getStringBounds(title, buffer).getWidth();
        buffer.drawString(title,  maxDiagLength/2 - stringLen/2, margin + nbmac*rectWidth+marginBetweenRect+30);
        
       try {
            
           ByteArrayOutputStream baos = new ByteArrayOutputStream();

           ImageIO.write( image, "png", baos );
           baos.flush();
           imageInByte = baos.toByteArray();
           baos.close();
            
       } catch (IOException ioe) {
           log.log(Level.OFF, ioe.toString());
       }
           
       return imageInByte;
           
   }
    
    
}
