/*
 * méthodes largement insiprées du web service réalisé par Maxime chassaing et pierre villechenon
 */

package JSTL_WS_package;

import java.util.Date;
import java.util.HashMap;
import java.util.Random;
import java.util.UUID;
import javax.annotation.Resource;
import javax.jws.WebService;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.ejb.Stateless;
import javax.servlet.http.HttpServletRequest;
import javax.xml.ws.Holder;
import javax.xml.ws.WebServiceContext;
import javax.xml.ws.handler.MessageContext;

/**
 *
 * @author damienl
 */
@WebService(serviceName = "WebService_JSTL")
@Stateless()
public class WebService_JSTL extends Methods {
    
    static int          NBMAX_CLIENTS;
    static long         MIN_TIME;
    static int          NBMAX_RESULTS;
    static int          TIME_MAX;
    static Result[][]   saveResult;
    static int[]        nbResult;
    static String[]     ipClient;
    static int[]        occupe;
    static long         startDate;
    static HashMap<String, Integer> map;
    static int NBMAX_REQUESTS;
    static int NBMAX_MAPCLIENTS;
    static int REBOOT_MAP;
    
    static {
        try {
            NBMAX_CLIENTS = 10; 
            NBMAX_RESULTS = 1;
            NBMAX_REQUESTS = 25;
            REBOOT_MAP = 5;
            TIME_MAX = 60; //minutes
            startDate = new Date().getTime();
            map = new HashMap<String, Integer>();
            NBMAX_MAPCLIENTS = 2000;
            //allocation des variables statiques
            saveResult = new Result[NBMAX_CLIENTS][NBMAX_RESULTS];
            occupe = new int[NBMAX_CLIENTS];
            ipClient = new String[NBMAX_CLIENTS];
            for (int i = 0 ; i < NBMAX_CLIENTS ; ++i) {
                ipClient[i] = "";
                occupe[i]=0;
            }
            nbResult = new int[NBMAX_CLIENTS];
        } catch (Exception ex){ }
    }
     
    @Resource // pour pouvoir récupérer des infos sur le client
    WebServiceContext wsContext; 
    
    
    /* -------------------------------------------------------------------------
    ****************************************************************************
    --------------------------- SYNCHRONOUS : ----------------------------------
    ****************************************************************************
    --------------------------------------------------------------------------*/
    
    // création d'un gantt
    @WebMethod(operationName = "getGantt")
    public byte[] getGantt(@WebParam(name = "un_probleme") Probleme un_probleme, @WebParam(name = "best_solution") Solution best_solution, @WebParam(name = "title") String title)  {
        byte[] imageInByte = null;
        if ( isOkHashMap() && un_probleme != null && best_solution != null) {
            imageInByte = createGantt( un_probleme,  best_solution,  title);
        }
        
        return imageInByte;
    }

    //fonction de création d'une instance de problème à partir d'un bytefile
    @WebMethod(operationName = "createProblem")
    public Probleme createProblem(@WebParam(name = "file") byte[] file) {
        Probleme un_prob = null;
        if (isOkHashMap() && file != null) {
           un_prob= new Probleme(file, log);
           if (un_prob.error < 0) {
              un_prob=null;
           }
        }
        
        return un_prob;
    }
    
    // méthode de génération d'une solution supportant un vecteur de Bierwirth
    @WebMethod(operationName = "generateCanBierwirth")
    public Solution generateCanBierwirth(@WebParam(name = "probleme") Probleme un_prob) { 
        Solution sol = null;
        if (isOkHashMap() &&  un_prob != null) {
            Random r = new Random();
            sol = new Solution(un_prob);
            generer_can_bierwirth(sol, un_prob, r);
            evaluateSol(sol, un_prob, 0); // on évalue du début en tentant de réparer les TL sans cycles
        }
        return sol;
    }  
    
    @WebMethod(operationName = "generateRandBierwirth")
    public Solution generateRandBierwirth(@WebParam(name = "probleme") Probleme un_prob) { 
        Solution sol = null;
        if (isOkHashMap() &&  un_prob != null) {
            Random r = new Random();
            sol = new Solution(un_prob);
            generer_rand_bierwirth(sol, un_prob, r);
            evaluateSol(sol, un_prob, 0); // on évalue du début en tentant de réparer les TL sans cycles
        }
        return sol;
    }
    
    @WebMethod(operationName = "generateSolFromGivenVector")
    public Solution generateSolFromGivenVector(@WebParam(name = "probleme") Probleme un_prob, @WebParam(name = "vecteur") int[] vect) {
        Solution sol = null;
        if (isOkHashMap()) { 
            int nbmac = un_prob.nbmac, nbjob= un_prob.nbjob;
            int n = nbmac*nbjob;
            int i =0;
            int nbjobInVect[] = new int[nbjob];
            
            // verification du vecteur client
            for (i=0; i < nbjob; ++i) {
                nbjobInVect[i]=0;
            }
            for (i = 0; i < n; i++) {
                nbjobInVect[vect[i]]++;
            }

            i = 0;
            while (i < nbjob && nbjobInVect[i]==nbmac) {
                i++;
            }

            // le compte est bon
            if ( i == nbjob) {
                sol = new Solution(un_prob, vect);
                evaluateSol(sol, un_prob, 0); // on évalue du début en tentant de réparer les TL sans cycles
            }
        }
        
        return sol;
    }
    
    // verification ddes droits du client selon le nombre de requêtes
    private boolean isOkHashMap() {
        //récupérer l'ip client 
        String ip_client = ((HttpServletRequest) wsContext.getMessageContext().get(MessageContext.SERVLET_REQUEST)).getRemoteAddr();
        
        if (map.containsKey(ip_client)) { // si la map contient l'ip
            if (map.get(ip_client) < NBMAX_REQUESTS ) { // si le client n'a pas dépassé le nombre de requetes
                int count = map.get(ip_client);
                map.put(ip_client, ++count);
                return true;
            } else { // le client a dépassé le nombre max de requetes
                if (((new Date().getTime() - startDate) / (60000 * 1.0f)) >= REBOOT_MAP) {
                    // si on a dépassé la durée de validité de la map
                    startDate =new Date().getTime();
                    map = null;
                    map = new HashMap<String, Integer>();
                    map.put(ip_client, 1);
                    return true;
                } else { // map toujours valide
                    return false;
                }
            }
        } else {
            if (map.size() < NBMAX_MAPCLIENTS) { // si il reste de la place dans la map
                map.put(ip_client, 1);
                return true;
            } else { // bye bye
                return false;
            }
        } 
    }
    
    // évaluation d'une solution
    @WebMethod(operationName = "evaluateSol")
    public Solution evaluateSol(@WebParam(name = "une_sol") Solution une_sol, @WebParam(name = "un_prob") Probleme un_prob, @WebParam(name = "start") int start) {
        if (isOkHashMap() && (un_prob != null) && (start >= 0 && start <= un_prob.nbjob*un_prob.nbmac) && (une_sol != null)) {
            evaluate(une_sol, un_prob, start, true);
        }

        return une_sol;
    }
    
    @WebMethod(operationName = "RechercheLocale")
    public Solution RechercheLocale(@WebParam(name = "une_sol") Solution une_sol, @WebParam(name = "un_prob") Probleme un_prob) {
        if (isOkHashMap() && (un_prob != null) && (une_sol != null)) {
            recherche_locale (une_sol, un_prob);
        }
        return une_sol;
    }
    
    // comptage du nombre de TL max violés
    @WebMethod(operationName = "countBrokenTL")
    public int countBrokenTimeLags(@WebParam(name = "une_sol") Solution une_sol, @WebParam(name = "un_prob") Probleme un_prob) {
        int a = 999999;
        if (isOkHashMap() && (un_prob != null) && (une_sol != null)) {
           a = countBrokenTL(une_sol, un_prob);
        }
        
        return a;
    }
    
    // tentative de réparation d'une solution
    @WebMethod(operationName = "repairSolution")
    public Solution repairSolution(@WebParam(name = "une_sol") Solution une_sol, @WebParam(name = "un_prob") Probleme un_prob) {
        if (isOkHashMap() && (un_prob != null) && (une_sol != null)) {
            repairSolution(une_sol, un_prob);
        } 
        return une_sol;
    }
    

    
    
    /* -------------------------------------------------------------------------
    ****************************************************************************
    --------------------------- ASYNCHRONOUS : GRASP ---------------------------
    ****************************************************************************
    --------------------------------------------------------------------------*/
    
    @WebMethod(operationName = "startGRASP")
    public String startGRASP (@WebParam(name = "fichier") byte[] file, @WebParam(name = "strErr", mode = WebParam.Mode.INOUT) Holder<String> strErr, int nbMaxVect, int nbMaxVoisin, int nbMaxDeplacement) {
        strErr.value = "The Data is NULL";
        String idGRASP = null;
        
        if (isOkHashMap() && nbMaxVect>0 && nbMaxDeplacement>0 && nbMaxVoisin>0 && nbMaxVect<500 && nbMaxDeplacement<500 && nbMaxVoisin<500) {
            Probleme un_probleme= new Probleme(file, log);
            if (un_probleme!=null && un_probleme.error==0) {
            
                int indiceC = 0;
                int indiceR = 0;
                int emplacementDispoClient = 0;
                int emplacementDispoFichier = 0;

                strErr.value = "";

                //récupérer l'ip client
                MessageContext mc = wsContext.getMessageContext();
                HttpServletRequest req = (HttpServletRequest)mc.get(MessageContext.SERVLET_REQUEST); 
                String ip_client = req.getRemoteAddr();

                //regarder si l'adresse IP du client existe dans ip
                while (indiceC < NBMAX_CLIENTS && ipClient[indiceC].compareTo(ip_client) != 0) {
                    ++indiceC;
                }
                //si le client n'existe pas déja
                if (indiceC >= NBMAX_CLIENTS) {
                    //checher un emplacement disponible
                    indiceC = 0;
                    while (indiceC < NBMAX_CLIENTS && occupe[indiceC] == 1) {
                        ++indiceC;
                    }

                    //si il n' y a plus d'emplacement disponible pour accueillir le nouveau client
                    if (indiceC >= NBMAX_CLIENTS) {
                        //chercher un client à supprimer (==> on supprimer un client si toutes ses demandes ont été lancé depuis plus de TPS_DE_VIE_MAX minutes)
                        emplacementDispoClient = suppressionClient();
                        //si emplacementDispo = -1 il n' y a pas de client a supprimer donc pas de places dispo
                        if (emplacementDispoClient == -1)
                        {
                            strErr.value = "Server is busy, too many clients";
                        } 
                    } else {
                        emplacementDispoClient = indiceC;
                    }

                    //si on a trouvé un emplacement dispo valide
                    if (emplacementDispoClient >= 0 && emplacementDispoClient < NBMAX_CLIENTS) {
                        //AJOUTER NOUVEAU CLIENT ET NOUVEAU FICHIER A TRADUIRE
                        emplacementDispoFichier = 0;
                        idGRASP = UUID.randomUUID().toString();
                        saveResult[emplacementDispoClient][emplacementDispoFichier] = new Result();
                        saveResult[emplacementDispoClient][emplacementDispoFichier].occupe = 1;
                        saveResult[emplacementDispoClient][emplacementDispoFichier].idResult = idGRASP;
                        saveResult[emplacementDispoClient][emplacementDispoFichier].dateStart = new Date().getTime();
                        saveResult[emplacementDispoClient][emplacementDispoFichier].isResultOk = 0;
                        saveResult[emplacementDispoClient][emplacementDispoFichier].erreur = "";
                        saveResult[emplacementDispoClient][emplacementDispoFichier].stop_Grasp = false;
                        ipClient[emplacementDispoClient] = ip_client;
                        occupe[emplacementDispoClient] = 1;
                        nbResult[emplacementDispoClient]++;
                    }            
                } else { // client connu à indiceC
                    //si le client a dépassé le nombre de fichier
                    if (nbResult[indiceC] >= NBMAX_RESULTS) {
                        //regarder si un fichier n'a pas dépassé la date
                        emplacementDispoFichier = suppressionFichier(indiceC);
                        if (emplacementDispoFichier == -1) {
                            strErr.value = "Too many Grasps in progress for the IP";
                        }
                    } else {
                        //rechercher la première place disponible (il y'en a une sur)
                        indiceR = 0;
                        while (indiceR < NBMAX_RESULTS && saveResult[indiceC][indiceR]!=null && saveResult[indiceC][indiceR].occupe == 1) {
                            indiceR++;
                        }
                        emplacementDispoFichier = indiceR;                
                    } 

                    if (emplacementDispoFichier >= 0 && emplacementDispoFichier < NBMAX_RESULTS) {
                        //AJOUTER NOUVEAU FICHIER CLIENT i
                        emplacementDispoClient = indiceC;
                        idGRASP = UUID.randomUUID().toString();
                        saveResult[emplacementDispoClient][emplacementDispoFichier] = new Result();
                        saveResult[emplacementDispoClient][emplacementDispoFichier].idResult = idGRASP;
                        saveResult[emplacementDispoClient][emplacementDispoFichier].dateStart = new Date().getTime();
                        saveResult[emplacementDispoClient][emplacementDispoFichier].isResultOk = 0;
                        saveResult[emplacementDispoClient][emplacementDispoFichier].erreur = "";
                        saveResult[emplacementDispoClient][emplacementDispoFichier].occupe = 1;
                        saveResult[emplacementDispoClient][emplacementDispoFichier].stop_Grasp = false;

                        nbResult[emplacementDispoClient]++;
                    }

                }

                //si pas d'erreur
                if (idGRASP != null) {
                    // si les données sont correct alors on débute le traitement
                    GRASP g  = new GRASP(un_probleme,emplacementDispoClient,emplacementDispoFichier, nbMaxVect, nbMaxDeplacement, nbMaxVoisin);
                    Thread t = new Thread(g);
                    t.start();
                    strErr.value = "algorithm launched";
                }
            }
        } else {
            strErr.value = "Error at launch";
            if (nbMaxVect<1 || nbMaxDeplacement<1 || nbMaxVoisin<1 || nbMaxVect>500 || nbMaxDeplacement>500 || nbMaxVoisin>500) {
                 strErr.value = "Wrong parameters";
            }
        }
        
        
        return idGRASP;
    }
    
    @WebMethod(operationName = "readGRASP")
    public Solution readGRASP(@WebParam (name = "id") String id,  @WebParam(name = "error", mode = WebParam.Mode.INOUT) Holder<Integer> error, @WebParam(name = "stringError", mode = WebParam.Mode.INOUT) Holder<String> stringError, @WebParam(name = "progress", mode = WebParam.Mode.INOUT) Holder<Integer> progress )  {
        Solution result = null;
        boolean stop = false;
        int indiceC = 0 , indiceR = 0;
        error.value = -5;
        stringError.value = "Too many requests"; 
        if (isOkHashMap()) {
            error.value = -1;
            stringError.value = "Key unknown"; 
            while (id != null && !stop && indiceC < NBMAX_CLIENTS) {
                indiceR = 0;
                while (!stop && indiceR < NBMAX_RESULTS) {
                    if (saveResult[indiceC][indiceR] != null && saveResult[indiceC][indiceR].occupe == 1 && id.compareTo(saveResult[indiceC][indiceR].idResult) == 0) {
                        //resultat dispo
                        if (saveResult[indiceC][indiceR].isResultOk == 1) {
                            //si le thread a généré une erreur 

                            if (saveResult[indiceC][indiceR].erreur.compareTo("OK") != 0) {
                                error.value = -3;
                                progress.value=saveResult[indiceC][indiceR].progress;
                                stringError.value = "Error during grasp :" + saveResult[indiceC][indiceR].erreur; 
                                result = new Solution(saveResult[indiceC][indiceR].sol, saveResult[indiceC][indiceR].un_prob);
                            } else  {
                                error.value = 0;
                                progress.value=saveResult[indiceC][indiceR].progress;
                                stringError.value = "Execution ok"; 
                                result = new Solution(saveResult[indiceC][indiceR].sol, saveResult[indiceC][indiceR].un_prob);
                            }

                            //si le client n'avait qu'un résultat => supprimer  client
                            if (nbResult[indiceC] == 1) {
                                saveResult[indiceC][indiceR].occupe = 0;
                                saveResult[indiceC][indiceR].isResultOk = 0;
                                saveResult[indiceC][indiceR].progress = 0;
                                saveResult[indiceC][indiceR].sol = null;
                                saveResult[indiceC][indiceR].stop_Grasp = false;
                                occupe[indiceC] = 0;
                                nbResult[indiceC] = 0;
                                ipClient[indiceC] = " ";

                            } else { //sinon enlever que le résultat
                                saveResult[indiceC][indiceR].occupe = 0;
                                nbResult[indiceC]--;
                                saveResult[indiceC][indiceR].isResultOk = 0;
                                saveResult[indiceC][indiceR].progress = 0;
                                saveResult[indiceC][indiceR].sol = null;
                                saveResult[indiceC][indiceR].stop_Grasp = false;
                            }
                        } else { //resultat pas dispo
                            error.value = -2;
                            progress.value=saveResult[indiceC][indiceR].progress;
                            stringError.value = "Execution still in progress";
                        }
                        stop = true;
                    }   
                    ++indiceR;
                }
                ++indiceC;
            }
        }
        return result;
    }
    
    
    @WebMethod(operationName = "stop_GRASP")
    public void stop_GRASP(@WebParam(name = "id")String id, @WebParam(name = "error", mode = WebParam.Mode.INOUT) Holder<Integer> error,@WebParam(name = "stringError", mode = WebParam.Mode.INOUT) Holder<String> stringError) {
        
        boolean stop = false;
        int indiceC = 0 , indiceR = 0;
        error.value = -1;
        stringError.value = "Key unknown"; 
        while (!stop && indiceC < NBMAX_CLIENTS) {
            indiceR = 0;
            while (!stop && indiceR < NBMAX_RESULTS) {
                if (saveResult[indiceC][indiceR] != null && saveResult[indiceC][indiceR].occupe == 1 && id.compareTo(saveResult[indiceC][indiceR].idResult) == 0) {
                    if (saveResult[indiceC][indiceR].isResultOk == 1) {
                        error.value = -2;
                        stringError.value = "Grasp already finished"; 
                    } else {
                        saveResult[indiceC][indiceR].stop_Grasp = true;
                        error.value = 0;
                        stringError.value = "Grasp stoped"; 
                    }
                    stop = true;
                }   
                ++indiceR;
            }
            ++indiceC;
        }
    }
    
    // suppression d'un client
    private int suppressionClient()  {
        int retour = -1;
        int indiceC = 0, indiceR = 0;
        boolean stop = false;
        boolean killClient;
        long dateCourante = new Date().getTime();
        float temps;
        while (!stop && indiceC < NBMAX_CLIENTS) {
            killClient = true;
            indiceR = 0;
            while(killClient && indiceR < NBMAX_RESULTS) {
                //si la case est occupée
                if (saveResult[indiceC][indiceR]!=null && saveResult[indiceC][indiceR].occupe == 1) {
                    //recupération du temps en min
                    temps = (dateCourante - saveResult[indiceC][indiceR].dateStart) / (60000 * 1.0f);

                    //si temps < temps max on doit garder le client
                    if (temps < TIME_MAX) {
                        killClient = false;
                    }
                }
                
                indiceR++;
            }
            //si on a trouvé un client à virer
            if (killClient) {
                // on garde l'indice du client pour retour
                retour = indiceC;
                nbResult[indiceC] = 0;
                indiceR = 0;
                // reinit
                while (indiceR < NBMAX_RESULTS) {
                    saveResult[indiceC][indiceR].occupe = 0;
                    saveResult[indiceC][indiceR].isResultOk = 0;
                    saveResult[indiceC][indiceR].progress = 0;
                    saveResult[indiceC][indiceR].stop_Grasp = false;
                    saveResult[indiceC][indiceR].sol = null;
                    indiceR++;
                }
                
                ipClient[indiceC] = "";
                // fini
                stop = true;
            }
            indiceC++;
        }
        return retour;
    }
    
    // suppression d'un fichier pour un client
    private int suppressionFichier(int indiceC) { 
        int retour = -1;
        int indiceR = 0; // indice resultat
        boolean stop = false;
        
        long dateCourante = new Date().getTime();
        float temps;
        //si on supprime c'est que toutes les cases dispo sont occupés
        while(!stop && indiceR < NBMAX_RESULTS) {
            //recupération du temps en min
            temps = (dateCourante - saveResult[indiceC][indiceR].dateStart) / (60000*1.0f);
            
            if (temps > TIME_MAX) {
                // supprimer le résultat
                retour = indiceR;
                nbResult[indiceC]--;
                saveResult[indiceC][indiceR].isResultOk = 0;
                saveResult[indiceC][indiceR].progress = 0;
                saveResult[indiceC][indiceR].stop_Grasp = false;
                saveResult[indiceC][indiceR].sol = null;
                stop = true;
            }
            indiceR++;
        }
        
        return retour;
    }
  
}
